<?php

// Reminder: always indent with 4 spaces (no tabs).
// +---------------------------------------------------------------------------+
// | Article_ex Plugin 1.0.0 for Geeklog - The Ultimate Weblog                 |
// +---------------------------------------------------------------------------+
// | private/plugins/article_ex/functions.inc                                  |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2008 Yoshinori Tahara - dengen                              |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id$

if (strpos ($_SERVER['PHP_SELF'], 'functions.inc') !== false) {
    die ('This file can not be used on its own.');
}

/**
* Language file Include
*/

$langfile = $_CONF['path'] . 'plugins/article_ex/language/'
          . $_CONF['language'] . '.php';

if ( file_exists( $langfile ) ) {
    include_once $langfile;
} else {
    include_once $_CONF['path'] . 'plugins/article_ex/language/english.php';
}

/*
* Include article_ex config file
*/

require_once $_CONF['path'] . 'plugins/article_ex/config.php';

/*
* テンプレートファイルのパスを設定する
*/
if ( is_dir( $_CONF['path_layout'] . 'article_ex' ) ) {
    $_AEX_CONF['path_templates'] = $_CONF['path_layout'] . 'article_ex';
} else if ( is_dir( $_CONF['path'] . 'plugins/article_ex/templates/' . $_CONF['theme'] ) ) {
    $_AEX_CONF['path_templates'] = $_CONF['path'] . 'plugins/article_ex/templates/' . $_CONF['theme'];
} else if ( ( !empty($_AEX_CONF['theme_compatibility_info'][$_CONF['theme']]) )
            && is_dir( $_CONF['path'] . 'plugins/article_ex/templates/' . $_AEX_CONF['theme_compatibility_info'][$_CONF['theme']] ) ) {
    $_AEX_CONF['path_templates'] = $_CONF['path'] . 'plugins/article_ex/templates/' . $_AEX_CONF['theme_compatibility_info'][$_CONF['theme']];
} else {
    $_AEX_CONF['path_templates'] = $_CONF['path'] . 'plugins/article_ex/templates/professional';
}

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Called by the plugin Editor to display the current plugin code version
* This may be different than the version installed and registered currently.
* If newer then you may want to run the update
*
* @return   string  version number
*
*/
function plugin_chkVersion_article_ex () 
{
    global $_AEX_CONF;
    
    return $_AEX_CONF['version'];
}

/**
* Upgrade the article_ex plugin
*
* @return   int     Number of message to display (true = generic success msg)
*
*/
function plugin_upgrade_article_ex ()
{
    global $_CONF, $_TABLES, $_AEX_CONF;

    // the plugin needs these functions so complain when they doesn't exist
    if (!function_exists ('COM_truncate') || !function_exists ('MBYTE_strpos')) {
        return 3002;
    }

    // no db changes - just update the version numbers
    DB_query ("UPDATE {$_TABLES['plugins']} SET pi_version = '{$_AEX_CONF['version']}', pi_gl_version = '"
            . VERSION . "' WHERE pi_name = 'article_ex'");

    return true;
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Default is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_article_ex ( $installCheck = '' )
{
    global $_TABLES, $LANG_AEX;

    $pi_name  = 'article_ex';
    $pi_admin = 'Article_ex Admin';

    // $FEATURES and $TABLES have to be changed accodrding to your plugin
    $FEATURES = array ( 'article_ex.admin' );
    $TABLES   = array ( 'comments_ex' );
    
    // Check and see if plugin is still enabled - if so display warning and exit
    if ( $installCheck != '' && DB_getItem ( $_TABLES['plugins'], 'pi_enabled', 'pi_name = "' . $pi_name . '"' ) ) {
        COM_errorLog ( "Plugin is installed and enabled. Disable first if you want to de-install it", 1 );
        $display .= COM_startBlock ( $LANG_AEX['warning'] );
        $display .= $LANG_AEX['enabled'];
        $display .= COM_endBlock ();
        echo $display;
        return false;
        exit;
    }
        
    // Ok to proceed and delete plugin

    // Drop Article_ex tables
    foreach ( $TABLES as $table ) {
        $t = $_TABLES["$table"];
        COM_errorLog ('Dropping $table table', 1);
        DB_query ( "DROP TABLE $t", 1 );
        COM_errorLog ('...success', 1);
    }

    // Remove Security for this plugin
    $grp_id = DB_getItem ($_TABLES['groups'], 'grp_id',"grp_name = '$pi_admin'");
    if (!empty ($grp_id)) {
        // Remove Article_ex Admin group from all other groups
        COM_errorLog ('Attempting to remove $pi_admin group from all groups' , 1);
        DB_query ("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id");
        COM_errorLog ('...success', 1);

        // Remove the Article_ex Admin group
        COM_errorLog('Attempting to remove the $pi_admin Group', 1);
        DB_query ("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id");
        COM_errorLog('...success', 1);
    }
    
    // Remove related features
    foreach ($FEATURES as $f) {
        $feat_id = DB_getItem ($_TABLES['features'], 'ft_id', "ft_name = '$f'");
        if (!empty ($feat_id)) {
            COM_errorLog ("Attempting to remove $f rights from all groups", 1);
            DB_query ("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id");
            COM_errorLog ('...success', 1);

            COM_errorLog ("Attempting to remove the $f feature", 1);
            DB_query ("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id");
            COM_errorLog ('...success', 1);
        }
    }
    
    // Unregister the plugin with Geeklog
    // Always attempt to remove these entries or lib-common.php would still
    // try and read our functions.inc file ...
    COM_errorLog ('Attempting to unregister the $pi_name plugin from Geeklog', 1);
    DB_query ("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = '$pi_name'");
    COM_errorLog ('...success',1);

    COM_errorLog ('Finished uninstalling the $pi_name plugin.', 1);

    return true;
}


function plugin_getListField_article_ex ($fieldname, $fieldvalue, $A, $icon_arr)
{
    global $_CONF, $LANG25, $LANG_ACCESS;

    $retval = '';

    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'],
                             $A['perm_owner'], $A['perm_group'],
                             $A['perm_members'], $A['perm_anon']);
    if ($access > 0) {
        switch($fieldname) {
            case 'edit':
                if ($access == 3) { // User is in Root group
                    $retval = "<a href=\"{$_CONF['site_admin_url']}/plugins/article_ex/index.php"
                            . "?mode=edit&amp;uid={$A['uid']}\">{$icon_arr['edit']}</a>";
                }
                break;
            default:
                $retval = $fieldvalue;
                break;
        }
    } else {
        $retval = false;
    }

    return $retval;
}


/**
* A user is about to be deleted. Update value of any comments owned
* by that user or delete them.
*
* @param    int     $uid    User id of deleted user
* @return   void
*
*/
function plugin_user_delete_article_ex ($uid)
{
    global $_TABLES, $LANG03;

    if (DB_count ($_TABLES['comments'], 'uid', $uid) == 0) {
        return;
    }
    
    $result = DB_query("SELECT cid FROM {$_TABLES['comments']} WHERE uid = $uid");
    while ( $A = DB_fetchArray ($result) ) {
        DB_query ("UPDATE {$_TABLES['comments_ex']} SET username = '" . $LANG03[24]
            . "', email = NULL, homepage = NULL WHERE cid = {$A['cid']}");
    }
}


/**
* A user is about to be deleted. Update value of any comments owned
* by that user or delete them.
*
* @param    int     $uid    User id of deleted user
* @return   void
*
*/
function plugin_user_changed_article_ex ($uid)
{
    global $_TABLES;

    if (DB_count ($_TABLES['comments'], 'uid', $uid) == 0) {
        return;
    }
    
    $username = DB_getItem($_TABLES['users'],'username', "uid = $uid");

    $result = DB_query("SELECT cid FROM {$_TABLES['comments']} WHERE uid = $uid");
    while ( $A = DB_fetchArray ($result) ) {
        DB_query ("UPDATE {$_TABLES['comments_ex']} SET username = '$username' WHERE cid = {$A['cid']}");
    }
}

?>
